%global momorel 1
%global rcver 9
# beta15 - rc8 were skipped
%global prever 25
%global plugins down-root auth-pam
%global md5sum_src0 f435e4ad43cf4323e942da570bae4951

Summary: A Secure UDP Tunneling Daemon
Name: openvpn
Version: 2.1
Release: 0.%{prever}.%{momorel}m%{?dist}
URL: http://openvpn.net/
# %%NoSource 0 http://openvpn.net/release/openvpn-%{version}.tar.gz %{md5sum_src0}
%NoSource 0 http://openvpn.net/release/openvpn-%{version}_rc%{rcver}.tar.gz %{md5sum_src0}
Source1: openvpn.init
# Sample 2.0 config files
Source2: roadwarrior-server.conf
Source3: roadwarrior-client.conf
Patch0: openvpn-init.patch
License: GPL
Group: Applications/Internet
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: lzo-devel >= 2.01, openssl-devel >= 0.9.8a, pam-devel
Requires: dev
Requires: chkconfig
PreReq: shadow-utils

# Filter out the perl(Authen::PAM) dependency.
# No perl dependency is really needed at all.
%define __perl_requires sh -c 'cat > /dev/null'

%description
OpenVPN is a robust and highly flexible tunneling application that
uses all of the encryption, authentication, and certification features
of the OpenSSL library to securely tunnel IP networks over a single
UDP port. It can use the Marcus Franz Xaver Johannes Oberhumer's LZO
library for compression.

%define debug_package %{nil}

%prep
%setup -q -n %{name}-%{version}_rc%{rcver}
%patch0 -p0
sed -i -e 's,%{_datadir}/openvpn/plugin,%{_libdir}/openvpn/plugin,' openvpn.8

# %%doc items shouldn't be executable.
find contrib sample-config-files sample-keys sample-scripts -type f -perm +100 \
    -exec chmod a-x {} \;

%build
%configure \
  --enable-pthread \
  --enable-password-save \
  --enable-iproute2 \
  --with-lzo-headers=%{_includedir}/lzo
%make

# Build plugins
for plugin in %{plugins} ; do
    %{__make} -C plugin/$plugin
done

%install
[ %{buildroot} != "/" ] && rm -rf %{buildroot}

install -D -m 0644 %{name}.8 $RPM_BUILD_ROOT%{_mandir}/man8/%{name}.8
install -D -m 0755 %{name} $RPM_BUILD_ROOT%{_sbindir}/%{name}
install -D -m 0755 sample-scripts/%{name}.init \
    $RPM_BUILD_ROOT%{_initscriptdir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pR easy-rsa $RPM_BUILD_ROOT%{_datadir}/%{name}/
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name}/easy-rsa/Windows
cp %{SOURCE2} %{SOURCE3} sample-config-files/

mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}/plugin/lib
for plugin in %{plugins} ; do
    install -m 0755 plugin/$plugin/openvpn-$plugin.so \
        $RPM_BUILD_ROOT%{_libdir}/%{name}/plugin/lib/openvpn-$plugin.so
    cp plugin/$plugin/README plugin/$plugin.txt
done

mkdir -m 755 -p $RPM_BUILD_ROOT%{_var}/run/%{name}

%clean
[ %{buildroot} != "/" ] && rm -rf %{buildroot}

%pre
if ! id openvpn > /dev/null 2>&1 ; then
    /usr/sbin/useradd -r -s /sbin/nologin -c OpenVPN -d /etc/openvpn openvpn
fi

%post
/sbin/chkconfig --add %{name}

%preun
if [ "$1" = 0 ]
then
    	/sbin/service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" -ge 1 ]; then
    /sbin/service %{name} condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING COPYRIGHT.GPL INSTALL NEWS PORTS README 
%doc plugin/*.txt
%{_mandir}/man8/%{name}.8*
%{_sbindir}/%{name}
%{_datadir}/%{name}
%{_libdir}/%{name}
%{_var}/run/%{name}
%config %{_initscriptdir}/%{name}
%config %dir %{_sysconfdir}/%{name}

%changelog
* Wed Aug  6 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.1-0.25.1m)
- [SECURITY] CVE-2008-3459
- version up 2.1-rc9

* Mon Jul 23 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (2.1-0.14.2m)
- add Requires: chkconfig

* Sun May 28 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.1-0.14.1m)
- version up 2.1-beta14

* Sun Apr  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.6-1m)
- version up
- rebuild against openssl-0.9.8a

* Tue Nov  8 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.5-1m)
- up to 2.0.5
- [SECURITY] CVE-2005-3393, CVE-2005-3409, 

* Wed Aug 24 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.1-1m)
- up to 2.0.1
- [SECURITY] CAN-2005-2531 CAN-2005-2532 CAN-2005-2533 CAN-2005-2534
- build with plugins

* Thu Jul 21 2005 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0-3m)
  rebuild against lzo-2.01

* Sun Jun 12 2005 Kazuhiko <kazuhiko@fdiary.net>
- (2.0-2m)
- rebuild against lzo-2.00

* Sat Jun 11 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0-1m)
- bug fix and support multi mode

* Thu Feb 17 2005 Toru Hoshina <t@momonga-linux.org>
- (1.6.0-2m)
- do not start/stop at %%post/%%postun.

* Wed Aug  4 2004 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.0-1m)
- initial import to Momonga
